$debug

function initGroup()
   GROUP_TAG = newtag()
   settagmethod(GROUP_TAG,"index",indexGroup)
end

function indexGroup(self, index)
   local i,v = next(self._list,nil)
   if i and type(v[index]) == "function" then
      if strsub(index,1,9) == "deferred_" then
         self[index] = function (...)
                          local label = strsub(%index,10)
                          return deferredGroup(label,arg)
                       end
      else
         self[index] = function (...)
                          return dispGroup(%index,arg)
                       end
      end
      return self[index]
   else
      return nil
   end
end

function dispGroup(index,arg)
   local self = arg[1]
   local tb = {}
   local f = function (i,v)
      local method = v["deferred_"..%index]
      %arg[1] = v
      %tb[i] = call(method,%arg)
   end
   foreach(self._list,f)

   local ret = {}
   local g = function(i,v)
      v:Wait()
      %ret[i] = call(v.GetResult,{v},"p")
   end
   foreach(tb,g)

   return ret
end

function deferredGroup(index,arg)
   local self = arg[1]
   local tb = {}
   local f = function (i,v)
      local method = v["deferred_"..%index]
      %arg[1] = v
      %tb[i] = call(method,%arg)
   end
   foreach(self._list,f)

   return tb
end

function Group_add_member(self,i,v)
   self._list[i] = v
end

function Group_remove_member(self,i)
   self._list[i] = nil
end

function Group(list)
   if not GROUP_TAG then
      initGroup()
   end
   local obj = {_list = list,
                _add = Group_add_member,
                _remove = Group_remove_member}
   settag(obj,GROUP_TAG)
   return obj
end
