# ---------------------------------------------------------------------------
# Use the following lines to set your installation directories
# ---------------------------------------------------------------------------
INC_DIR = ./include
LIB_DIR = ./lib/ob3-Linux
OBJ_DIR = ./obj/ob3-Linux
BIN_DIR = ./bin
SRC_DIR = ./src/library
DEMO_DIR = ./demo
DEMO_SRC_DIR = ./src/bin
DEMO_INC_DIR = ./src/bin


# ---------------------------------------------------------------------------
# Use the following lines to set the directories where Lua is installed
# ---------------------------------------------------------------------------
LUA_DIR = @lua_dir@
LUA_INC = $(LUA_DIR)/include
LUA_LIB = $(LUA_DIR)/lib

# ---------------------------------------------------------------------------
# Use the following lines to set the directories where ORBacus is installed
# ---------------------------------------------------------------------------
OB_DIR = @orb_dir@
OB_INC = $(OB_DIR)/include
OB_LIB = $(OB_DIR)/lib

# ---------------------------------------------------------------------------
# Use the following lines to set the directories where JTC is installed,
# and the required options to compile and link with JTC
# Note: LuaOrb does not require JTC, so you can comment these lines.
# You only need the settings below if your ORBacus library was compiled with JTC
# ---------------------------------------------------------------------------
JTC_DIR = @jtc_dir@
JTC_INC = $(JTC_DIR)/include
JTC_LIB = $(JTC_DIR)/lib
@use_jtc_inc@ = -I$(JTC_INC)
@use_jtc_lib@ = -L$(JTC_LIB) -lJTC -lpthread

# ---------------------------------------------------------------------------
# Compiler options
# ---------------------------------------------------------------------------
CC = g++

INCS = -I$(OB_INC) -I$(LUA_INC) -I$(INC_DIR) -I$(SRC_DIR) $(USE_JTC_INC)

# Comment the following line if you don't want debug information
@use_debug@ = -g

CFLAGS = $(USE_DEBUG) -Wall --no-implicit-templates $(INCS) -DORB_ORBACUS -fPIC

# ---------------------------------------------------------------------------
# Linker options
# ---------------------------------------------------------------------------

LFLAGS = -fPIC -L$(LIB_DIR) -L$(LUA_LIB) -L$(OB_LIB) -lluaorb -llua -llualib -lOB $(USE_JTC_LIB)

# ---------------------------------------------------------------------------
# Target options
# ---------------------------------------------------------------------------
LOLIB = $(LIB_DIR)/libluaorb.a
LOCONSOLE = $(BIN_DIR)/luaorb

# ---------------------------------------------------------------------------
# Other definitions
# ---------------------------------------------------------------------------
SHELL = /bin/sh
