# ---------------------------------------------------------------------------
# Use the following lines to set your installation directories
# ---------------------------------------------------------------------------
INC_DIR = .\include
LIB_DIR = .\lib
OBJ_DIR = .\obj
BIN_DIR = .\bin
SRC_DIR = .\src\library
DEMO_DIR = .\demo
DEMO_SRC_DIR = .\src\bin
DEMO_INC_DIR = .\src\bin

# ---------------------------------------------------------------------------
# Use the following lines to set the directories where Lua is installed
# ---------------------------------------------------------------------------
LUA_DIR = @lua_dir@
LUA_INC = $(LUA_DIR)\include
LUA_LIB = $(LUA_DIR)\lib

# ---------------------------------------------------------------------------
# Use the following lines to set the directories where ORBacus is installed
# ---------------------------------------------------------------------------
OB_DIR = @orb_dir@
OB_INC = $(OB_DIR)\include
OB_LIB = $(OB_DIR)\lib

# ---------------------------------------------------------------------------
# Use the following lines to set the directories where JTC is installed,
# and the required options to compile and link with JTC
# Note: LuaOrb does not require JTC, so you can comment these lines.
# You only need the settings below if your ORBacus library was compiled with JTC
# ---------------------------------------------------------------------------
JTC_DIR = @jtc_dir@
JTC_INC = $(JTC_DIR)\include
JTC_LIB = $(JTC_DIR)\lib
@use_jtc_inc@ = -I$(JTC_INC)
@use_jtc_lib@ = $(JTC_LIB)/jtc.lib

# ---------------------------------------------------------------------------
# Compiler options
# ---------------------------------------------------------------------------
CC = CL

INCS = -I$(OB_INC) -I$(LUA_INC) -I$(INC_DIR) -I$(SRC_DIR) $(USE_JTC_INC)

# Comment the following line if you don't want debug information
@use_debug@ = /Zi /Od /Yd

CFLAGS = /GX /GR /MD $(USE_DEBUG) $(INCS) -DWIN32 -DORB_ORBACUS

.SUFFIXES:
.SUFFIXES: .cpp .obj

# ---------------------------------------------------------------------------
# Linker options
# ---------------------------------------------------------------------------
DEFAULT_LIBS = kernel32.lib user32.lib shell32.lib wsock32.lib advapi32.lib

LFLAGS = /nologo /subsystem:console /incremental:no /machine:I386 $(LOLIB) $(LUA_LIB)/lua.lib $(LUA_LIB)/lualib.lib $(OB_LIB)/ob.lib $(USE_JTC_LIB) $(DEFAULT_LIBS)

# ---------------------------------------------------------------------------
# Target options
# ---------------------------------------------------------------------------
LOLIB = $(LIB_DIR)\luaorb.lib
LOCONSOLE = $(BIN_DIR)\luaorb.exe
