include ./config.mak


all: $(LIB_DIR) $(OBJ_DIR) $(BIN_DIR) $(LOLIB) $(LOCONSOLE)

$(LIB_DIR)::
	if not exist $(LIB_DIR) \
	   mkdir $(LIB_DIR)

$(OBJ_DIR)::
	if not exist $(OBJ_DIR) \
	   mkdir $(OBJ_DIR)

$(BIN_DIR)::
	if not exist $(BIN_DIR) \
	   mkdir $(BIN_DIR)

clean-obj:
	del $(OBJ_DIR)\*.obj 
	rmdir $(OBJ_DIR)

clean:
	del $(OBJ_DIR)\*.obj 
	rmdir $(OBJ_DIR)
	del $(LIB_DIR)\*.lib 
	rmdir $(LIB_DIR)
	del $(BIN_DIR)\*.exe 
	rmdir $(BIN_DIR)

LIB_OBJS = $(OBJ_DIR)/lo_proxy.obj $(OBJ_DIR)/lua2tk.obj $(OBJ_DIR)/lo_omni.obj $(OBJ_DIR)/lo_tcode.obj $(OBJ_DIR)/lo_cfg.obj $(OBJ_DIR)/lo_dsi.obj $(OBJ_DIR)/luawrap.obj $(OBJ_DIR)/luaorb.obj $(OBJ_DIR)/lo_class.obj

$(LOLIB): $(LIB_OBJS)
	lib /NOLOGO /OUT:$@ $(LIB_OBJS)


{$(SRC_DIR)}.cpp{$(OBJ_DIR)}.obj:
	$(CC) /c $(CFLAGS) /Fo$@ $<

{$(DEMO_SRC_DIR)}.cpp{$(OBJ_DIR)}.obj:
	$(CC) /c $(CFLAGS) /Fo$@ $<


BIN_OBJS = $(OBJ_DIR)/console-vb.obj $(OBJ_DIR)/utils.obj $(OBJ_DIR)/cotimer.obj $(LOLIB)

$(LOCONSOLE): $(BIN_OBJS)
	link /out:$@ $(BIN_OBJS) $(LFLAGS)

include ./mak/dependences.mak

