Hi,

You mean, your program must perform some work in background while
the ORB::run method is running. Is this what you want? If so, use
a timer function that will be called after a given time. To do this,
you have to subclass CORBA::DispatcherCallback and implement the callback
method of this class.

e.g.

#define TIMER_DELAY 100   // in milliseconds
class MyCallback : public CORBA::DispatcherCallback {
  public:
 ~MyCallback() { }
  
  callback(CORBA::Dispatcher *d, CORBA::Dispatcher::Event event) {
    if (event == CORBA::Dispatcher::Timer) {
       // Perform your work !
       //  like calling loadMonitor->body();
       // You could store a LoadMonitor instance pointer in
       // This object.

       // Register again...
       d->tm_event(this, TIMER_DELAY);
    }
  }
};

  in your main:

  MyCallback callback;

  orb->dispatcher()->tm_event(&callback, TIMER_DELAY);

e/ou 
  orb->dispatcher()->rd_event(&callback, stdin);

 
 This should work.

