#include <stdio.h>
#include <conio.h>
#include <ctype.h>

extern "C"
{
#include <lua.h>
#include <lualib.h>
}

#include <corba.h>
#include <dispatch/dispatch.h>

#include <luaorb.h>

#include "utils.h"
#include "cotimer.h"

CORBA::ORB_ptr orb = NULL;
CORBA::BOA_ptr boa = NULL;

class KHandler : public IOHandler
{
   char input_[1000];
   int len;

   void Register()
   {
      Dispatcher::instance().startTimer(0,1000,this);
   }
public:

   KHandler()
   {
      input_[0] = '\0';
      len = 0;
      fflush(stdin);
      setvbuf(stdin,NULL,_IONBF,0);
      Register();
   }

   virtual void timerExpired(long,long)
   {
      if(_kbhit())
      {
         char c;
         c = _getch();

         switch(c)
         {
         case '\b':
         {
            if(len > 0)
            {
               input_[len - 1] = '\0';
               len--;
               cout << "\b \b" << flush;
            }
            break;
         }
         case '\r':
         {
            cout << endl << flush;
            lua_dostring(input_);
            input_[0] = '\0';
            len = 0;
            cout << "> " <<  flush;
            break;
         }
         default:
         {
            if(isprint(c))
            {
               cout << c << flush;
               input_[len] = c;
               len++;
               input_[len] = '\0';
            }  
            break;
         }
         }
      }
      Register();
   }
};

static void my_exit()
{
   orb->shutdown();
}

int main(int argc, char** argv)
{
   iolib_open();
   strlib_open();
   mathlib_open();

   orb = CORBA::ORB_init(argc, argv);
   boa = orb->BOA_init(argc, argv);

   luaorb_open(orb,boa);

   cotimer_open();
   int interactive = proc_params(argc,argv);

   KHandler* handler = 0;

   if (interactive)
   {
      handler = new KHandler;
      cout << "LuaOrb Console v. 1.5" << endl;
      cout << "> " << flush;
   }

   lua_register("exit",my_exit);

   boa->impl_is_ready();

   if (handler)
      delete handler;

   luaorb_close();
   lua_close();

   return 0;
}
