#include <stdio.h>

extern "C"
{
#include <lua.h>
#include <lualib.h>
}

#include <OB/CORBA.h>
#include <luaorb.h>

#include "wreactor-ob3.h"
#include "utils.h"
#include "cotimer.h"


CORBA_ORB_ptr orb = NULL;
CORBA_BOA_ptr boa = NULL;


static void my_exit()
{
   boa->deactivate_impl(CORBA_ImplementationDef::_nil());
   WConsoleReactor::Close();
}

int main(int argc, char** argv)
{
   iolib_open();
   strlib_open();
   mathlib_open();

   WConsoleReactor::Init("LuaOrb Console - version 1.5");

   orb = CORBA_ORB_init(argc, argv);
   boa = orb->BOA_init(argc, argv);
   orb -> conc_model(CORBA_ORB::ConcModelReactive);
   boa -> conc_model(CORBA_BOA::ConcModelReactive);
   boa -> init_servers();


   luaorb_open(orb,boa);

   cotimer_open();

   int interactive = proc_params(argc,argv);


   if (interactive)
      WConsoleReactor::Start();

   lua_register("exit",my_exit);

   boa->impl_is_ready(CORBA_ImplementationDef::_nil());

   luaorb_close();
   lua_close();

   CORBA_release(boa);
   CORBA_release(orb);

   return 0;
}
