#include <string.h>
#include <stdio.h>
extern "C"{
#include <lua.h>
}

#include "utils.h"

static void set_field(lua_Object table, int index, char* val)
{
   lua_pushobject(table);
   lua_pushnumber((double)index);
   lua_pushstring(val);
   lua_settable();
}

int proc_params(int argc, char** argv)
{
   lua_Object lua_args = lua_createtable();

   lua_pushobject(lua_args);
   lua_setglobal("argv");

   lua_pushobject(lua_args);
   lua_pushstring("n");
   lua_pushnumber((double)argc);
   lua_settable();

   int interactive = 1;

   for (int i = 0; i < argc; i++)
   {
      set_field(lua_args,i+1,argv[i]);
      if (strcmp(argv[i],"-i")==0)
         interactive = 2;
   }

   if (argc > 1)
   {
      char* file = argv[argc-1];
      int size = strlen(file);
      if ((size > 4 && strcmp((file+size-4),".lua")==0) ||
          (size > 3 && strcmp((file+size-3),".lo")==0))

      {
         int result = lua_dofile(file);
         if (result == 2)
         {
           fprintf(stderr, "luaorb: cannot execute file %s\n", file);
         }
         interactive--;
      }
      
   }

   return interactive;
}
