//*****************************************************************************
//
// LuaOrb Library
// Computer Science Department of PUC-Rio
// Rio de Janeiro, Brazil
//
// $Id: lo_compt.h,v 1.5 1999/11/25 20:33:25 rcerq Exp $
//
//*****************************************************************************


#ifndef LOCOMPT_H
#define LOCOMPT_H

class Compat
{
public:
   
   class Marshal
   {
   public:
      virtual ~Marshal() {};
      virtual void put(CORBA::Any& any) = 0;
      virtual void to_any(CORBA::Any* any) = 0;
   };

   class Unmarshal
   {
   public:
      virtual ~Unmarshal() {};
      virtual CORBA::Any* get() = 0;
   };

   static Marshal* create_union_marshaller(CORBA::TypeCode_ptr tc);
   static Marshal* create_struct_marshaller(CORBA::TypeCode_ptr tc);
   static Marshal* create_sequence_marshaller(CORBA::TypeCode_ptr tc,
                                        unsigned long size);
   static Marshal* create_array_marshaller(CORBA::TypeCode_ptr tc);

   static Unmarshal* create_union_unmarshaller(CORBA::TypeCode_ptr tc,
                                          const CORBA::Any& any);
   static Unmarshal* create_struct_unmarshaller(CORBA::TypeCode_ptr tc,
                                          const CORBA::Any& any);
   static Unmarshal* create_sequence_unmarshaller(CORBA::TypeCode_ptr tc,
                                            const CORBA::Any& any,
                                            unsigned long* length);
   static Unmarshal* create_array_unmarshaller(CORBA::TypeCode_ptr tc,
                                         const CORBA::Any& any);
};

#endif
