//*****************************************************************************
//
// LuaOrb Library
// Computer Science Department of PUC-Rio
// Rio de Janeiro, Brazil
//
// $Id: lo_dsi.h,v 1.11 2000/06/21 21:43:47 rcerq Exp $
//
//*****************************************************************************


/*
 * DSIluaman / DSI Lua Manager
 *
 */
#ifndef __LO_DSI_H
#define __LO_DSI_H

#include "lo_class.h"
#include "luawrap.h"

#ifdef CORBA_2_3
class LuaDSI: public PortableServer::DynamicImplementation,
              public PortableServer::RefCountServantBase
#else
class LuaDSI: public CORBA::DynamicImplementation
#endif
{
public:

   LuaOrbClass* myclass;
   static LuaWrapper* Wrapper;

//metodo para a inicializacao deste componente
   static void open();

//metodo para a finalizacao deste componente
   static void close();

//metodos para a instanciacao de novos servidores LuaDSI
   static LuaDSI* Create(CORBA::InterfaceDef_ptr intf,lua_Object lua_obj, char*name=0);
   static LuaDSI* Create(char* InterfaceName,lua_Object lua_obj, char*name=0);
   static LuaDSI* Create(char* InterfaceName,char* id,lua_Object lua_obj, char*name=0);

   LuaDSI( lua_Object table, LuaOrbClass* lo_class, char* name = 0 );
   ~LuaDSI();

//metodos redefinidos da interface CORBA::DynamicImplementation 
   virtual CORBA::Boolean _is_a(const char *name);
   virtual CORBA::InterfaceDef_ptr _get_interface();

   #ifdef CORBA_2_3
   CORBA::RepositoryId _primary_interface(const PortableServer::ObjectId& oid, PortableServer::POA_ptr poa);
   #endif

   virtual void invoke(CORBA::ServerRequest_ptr request);

//metodos da interface LuaDSI
   virtual lua_Object GetLuaObject();
   virtual void SetLuaObject( lua_Object lua_obj);
   virtual void RaiseException(CORBA::ServerRequest_ptr request,
                               MethodDescr* descr, lua_Object exception);

private:
   static int EXCEPTION_TAG;
   int tableLuaRef;
   LuaDSI* nextServer;
   LuaDSI* prevServer;

   static LuaDSI* firstServer;
   static void insertServer(LuaDSI* server);
   static void removeServer(LuaDSI* server);
   static void destroyServerList();

public:
#ifdef ORB_ORBACUS
   OB_MAKE_NARROW_IMPL(LuaDSI)
#endif
};

#endif
