//*****************************************************************************
//
// LuaOrb Library
// Computer Science Department of PUC-Rio
// Rio de Janeiro, Brazil
//
// $Id: lo_proxy.h,v 1.27 2000/06/21 21:43:47 rcerq Exp $
//
//*****************************************************************************


#ifndef LO_PROXY_H
#define LO_PROXY_H

#include "lo_class.h"
#include "luawrap.h"

enum InvokeMode { NORMAL_CALL, DEFERRED_CALL};

class LuaOrb
{
   int lua_this;

   void CreateLuaThis();

public:
   class DeferredClosure
   {
      int _finished;
   public:
      LuaOrb* object;
      CORBA::Request_ptr req;
      CORBA::Any* resultAny;
      CORBA::NVList_ptr arguments;
      MethodDescr* method_descr;
      AttribDescr* attrib_descr;

      DeferredClosure()
      { object = NULL; req = NULL; resultAny = NULL; arguments = NULL;
        method_descr = NULL; attrib_descr = NULL; _finished = 0;}
      ~DeferredClosure()
      { if (req != NULL)
          CORBA_release(req);
      }
      int Finished();
      void Wait();
      void GetResult();
   };

   // TAGs
   static int TAG;
   static int UDTAG;
   static char*  DEFCLOSURE_TAG;
   static LuaWrapper* DefClosureWrapper;

   static void open();
   static void close();
   static LuaOrb* new_obj(const char* id, const char* iname,
                          CORBA::Object_ptr orb_obj);
   static void push(LuaOrb* obj);
   static LuaOrb* check_tag(int index);
   static LuaOrb* from_lua(lua_Object l_obj);
   static char* parsename(char* full_name, InvokeMode* mode);

   LuaOrbClass* myclass;
   CORBA::Object_ptr orb_object;
   int locked;

   LuaOrb(const char* id, const char* interfacename,
          CORBA::Object_ptr orb_obj);
   virtual ~LuaOrb();

   lua_Object GetLuaThis();
   void SetLuaThis( lua_Object l_obj );

   lua_Object  GetLuaExceptionHandler();

   void Call(MethodDescr* method_descr, InvokeMode mode, LuaObjList* list);
   void SetAttr(AttribDescr* attrib_descr, InvokeMode mode, lua_Object l_obj);
   void GetAttr(AttribDescr* attrib_descr, InvokeMode mode);
   void RaiseException( CORBA::Exception* excep, MethodDescr* descr);
};


#endif
