//*****************************************************************************
//
// LuaOrb Library
// Computer Science Department of PUC-Rio
// Rio de Janeiro, Brazil
//
// $Id: luawrap.h,v 1.3 1999/11/25 20:33:25 rcerq Exp $
//
//*****************************************************************************

#ifndef LUAWRAPPER_H
#define LUAWRAPPER_H

class LuaWrapper
{
   static int initialized;
   static char* init_code;

   struct MethodsList
   {
      int n;
      struct luaL_reg* table;
   };

   int tag;
   int ud_tag;
   char* tag_name;
   MethodsList* mlist;

protected:
   LuaWrapper( const char* name );
public:
   static LuaWrapper* createWrapper(const char* name);
   static LuaWrapper* getWrapper(const char* name);

   virtual ~LuaWrapper();

   void  reg_tagmethods(struct luaL_reg* table, int n);
   void  reg_ud_tagmethods(struct luaL_reg* table, int n);
   void  reg_methods(struct luaL_reg* table, int n);
   void  push(void* userdata);
   void* check_tag(int index);
   void* from_lua(lua_Object luaobj);
};
#endif
